/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractParameter;
import javax.faces.event.ActionListener;
import org.ajax4jsf.component.JavaScriptParameter;

/**
 *  <p>
 The &lt;a4j:param&gt; behavior combines the functionality of the JavaServer Faces (JSF) components
 &lt;f:param&gt; and &lt;f:actionListener&gt;.
 </p>
 @author shura, alexsmirnov

 **/
@Generated({"RichFaces CDK", "4.3.1.Final-redhat-1"})
public class UIParameter extends AbstractParameter
    implements ActionListener,JavaScriptParameter    {

    public static final String COMPONENT_TYPE="org.richfaces.Parameter";

    public static final String COMPONENT_FAMILY="javax.faces.Parameter";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }






    protected enum Properties {
        assignTo,
        noEscape
        
    }

 
    public Object getAssignTo() {
        Object value = (Object) getStateHelper().eval(Properties.assignTo);
        return value;
    }
    
    public void setAssignTo(Object assignTo) {
        getStateHelper().put(Properties.assignTo, assignTo);
    }

 
    public boolean isNoEscape() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.noEscape, false);
        return value;
    }
    
    public void setNoEscape(boolean noEscape) {
        getStateHelper().put(Properties.noEscape, noEscape);
    }

    

}
